hector-fleet-management-system-master/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


// Resources
Route::resource('vehicles', 'VehicleController');
Route::resource('departments', 'DepartmentController');
Route::resource('vehicle_models', 'VehicleModelController');
Route::resource('orders', 'OrderController');
Route::resource('order_requests', 'OrderRequestController');


Route::get('/home', 'HomeController@index')->name('home');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

hector-fleet-management-system-master/app/Order.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    public function user() {
        return $this->belongsTo(User::class);
    }

    public function order_status() {
        return $this->belongsTo(Order_status::class);
    }

    public function vehicle_models() {
    	return $this->belongsToMany('App\Vehicle_model', 'order_vehicle_model')
    		->withPivot('quantity');
    }

        public function vehicles() {
    	return $this->belongsToMany('App\Vehicle', 'order_vehicle');
    }
}

hector-fleet-management-system-master/app/Http/Controllers/OrderController.php
<?php

namespace App\Http\Controllers;

use App\Order;
use App\Vehicle_model;
use App\Vehicle;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\DB;

use Session;

class OrderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Order $order)
    {
        $this->authorize('viewAny', $order);

        return view('orders.index')->with('orders', Order::all());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // if(Auth::user())

        return view('orders.create');
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(!Session::get('order_request')) {
            $request->session()->flash('fail', 'There are no veicles requested');

            return redirect()->back();
        }

        $borrow_date = $request->borrow_date;

        $request->validate([
            'borrow_date' => 'required|after_or_equal:' . date('F d, Y'),
            'return_date' => 'required|after_or_equal:' . date('F d, Y'), $request->borrow_date,
            'purpose' => 'required'
        ]);


        // Create order
        $order = new Order;
        $order->order_number = Auth::user()->id . "-" . time() . "-" . rand(pow(10, 2), pow(10, 5)-1);
        $order->user_id = Auth::user()->id;
        $order->borrow_date = $request->input('borrow_date');
        $order->return_date = $request->input('return_date');
        $order->purpose = $request->purpose;

        $order->save();

        // Set vehicle models
        $request_model_ids = array_keys(Session::get('order_request'));
        $request_models = Vehicle_model::find($request_model_ids);

        // Add models to order
        foreach($request_models as $model) {
            $model->quantity = Session::get("order_request.$model->id");
            $order->vehicle_models()->attach($model->id,
                [
                    'quantity' => $model->quantity
                ]);
        }

        $order->save();

        $request->session()->forget("order_request");

        return redirect(route('orders.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function show(Order $order, Request $request)
    {
        $this->authorize('view', $order);

        $requested_models = [];
        foreach($order->vehicle_models->all() as $vehicle_model) {
            array_push($requested_models, $vehicle_model->id);
        }

        $assigned_vehicles = [];
        foreach($order->vehicles as $vehicle) {
            array_push($assigned_vehicles, $vehicle->id);
        }

        $vehicles = Vehicle::whereIn('vehicle_model_id', $requested_models)
            ->whereNotIn('id', $assigned_vehicles)
            ->get();

        $available_vehicles = [];

        foreach($vehicles as $vehicle) {
            $is_available = true;
            if($vehicle->orders->first()) {
                foreach($vehicle->orders as $vehicle_order) {
                    if($vehicle_order->borrow_date < $order->borrow_date
                        && $vehicle_order->return_date > $order->borrow_date
                        || $vehicle_order->borrow_date < $order->return_date
                        && $vehicle_order->return_date > $order->return_date) {
                        
                        $is_available = false;
                        break;
                    }
                }
            }
            if($is_available) {
                $available_vehicles[] = $vehicle;
            }
        }

        return view('orders.show')->with('order', $order)
            ->with('vehicles', $available_vehicles)->with('statuses', DB::table('order_statuses')->where('id', '<', 4)->get());
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function edit(Order $order)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Order $order)
    {
        if($request->query('delete')) {
            $order->vehicle_models()->wherePivot('vehicle_model_id', $request->query('delete'))->detach();

            $request->session()->flash('success', "Successfully removed model from request");

        } elseif($request->query('updateQuantity')) {
            $request->validate([
                'quantity' => 'required|min:1'
            ]);

            DB::table('order_vehicle_model')
                ->where('vehicle_model_id', $request->query('updateQuantity'))
                ->update(['quantity' => $request->quantity]);

            $request->session()->flash('success', "Successfully removed model from request");

        } elseif($request->query('assign')) {
            if($order->vehicles->where('id', $request->input('assign'))->first()) {
                $request->session()->flash('fail', 'Vehicle already assigned in the order');
                // dd($order->vehicles()->get());
            } else {
                $order->vehicles()->attach($request->input('assign'));
                $request->session()->flash('success', 'Vehicle assigned to order');
                // dd($order->vehicles()->get());
            }
            
        } elseif($request->query('unassign')) {
            $order->vehicles()->detach($request->unassign);
            $request->session()->flash('success', 'Vehicle unassigned from order');
            
        } elseif($request->reject !== null) {
            $order->order_status_id = 4;
            $order->save();
        } else {

            if(Auth::user()->can('isUser') && $order->status_id !== 2) {
                $request->validate([
                    'borrow_date' => 'required',
                    'return_date' => 'required|after_or_equal:' .  $request->borrow_date,
                    'purpose' => 'required'
                ]);
                $order->purpose = $request->purpose;
                $order->borrow_date = $request->input('borrow_date');
                $order->return_date = $request->input('return_date');
                
            }

            $order->order_status_id = $request->status;
            $order->save();
        }

        return redirect(route('orders.show', ['order'=> $order->id]))->with('user', Auth::user());
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, Order $order)
    {
        $order->delete();
        $request->session()->flash('success', 'Order successfully deleted');

        return redirect(route('orders.index'));
    }
}

hector-fleet-management-system-master/resources/views/orders/create.blade.php
@extends('layouts.app')

@section('content')

<!-- BANNER -->

{{-- Start of Messages --}}
@include('messages')
{{-- End of Messages --}}

<div class="row px-3">
	<div class="col-12 text-center">
	    <h1>Create Order</h1>
	</div>
</div>

<!-- MAIN CONTENT -->
<div class="row section">
	
	<div class="col-sm-7 mb-3">
		<div class="card">
			<div class="card-header">
				Fill-up details
			</div>
			<div class="card-body">
				<form action="#">
					<div class="form-group">
						<label for="borrow-date">
							Borrow Date:
						</label>
						<input type="date" class="form-control" name="borrow-date">
					</div>
					<div class="form-group">
						<label for="return-date">
							Return Date:
						</label>
						<input type="date" class="form-control" name="return-date">
					</div>
					<div class="form-group">
						<label for="purpose">Purpose:</label>
						<textarea name="purpose" id="purpose" rows="5" class="form-control"></textarea>
					</div>

					<div class="col-sm-6 col-lg-4 mx-auto">
						<button class="btn btn-primary w-100">Submit</button>
					</div>
				</form>
			</div>
		</div>
	</div>

	<div class="col-sm-5 mb-3">
		
	</div>

</div>

@endsection

hector-fleet-management-system-master/resources/views/orders/index.blade.php
@extends('layouts.app')

@section('content')

{{-- Start of Messages --}}
@include('messages')
{{-- End of Messages --}}

<!-- MAIN CONTENT -->
<div class="row">
    <div class="col-12 col-lg-8 mx-auto">
        <div class="accordion w-100" id="order-list">
            {{-- Start Order Item List --}}
            @foreach($orders as $order)
                @can('viewOrder', $order)
                <div class="card">
                    <div class="order card-header px-0" id="order-{{ $order->id }}">
                            <button class="btn btn-link" type="button" data-toggle="collapse" data-target="#details-{{ $order->id }}" aria-expanded="true" aria-controls="details-{{ $order->id }}">
                                <h5 class="mb-0">{{$order->order_number}}</h5>
                            </button>
                            <div class="d-inline text-light float-right mb-3 mr-3 px-2 py-1
                            @if($order->order_status->id == 2 && date('Y-m-d') > $order->return_date)
                                bg-danger
                            @elseif($order->order_status_id === 1)
                                bg-grey
                            @elseif($order->order_status_id === 2)
                                bg-success
                            @elseif($order->order_status_id === 3)
                                bg-primary
                            @elseif($order->order_status_id === 4)
                                bg-warning
                            @endif
                            
                        ">
                            {{ $order->order_status->id == 2 && date('Y-m-d') > $order->return_date? "OVERDUE" : $order->order_status->name }}
                        </div>
                        <div class="col-12 text-dark">
                            {{date('M-d-Y', strtotime($order->created_at))}} | {{ ucwords($order->user->firstname . " " . $order->user->lastname)}}
                        </div>
                    </div>
                
                    <div id="details-{{ $order->id }}" class="collapse" aria-labelledby="order-ID" data-parent="#order-list">
                        <div class="card-body row py-0 bordered">
                            <table class="table col-sm-6 my-0">
                                <tr class="row px-3">
                                    <td class="col-6">Vehicles Requested:</td>
                                    <td class="col-6">{{ count($order->vehicle_models()->get()) }}</td>
                                </tr>
                                <tr class="row px-3">
                                    <td class="col-6">Last Update:</td>
                                    {{-- {{ dd($order->updated_at) }} --}}
                                    <td class="col-6">{{date('F d, Y', strtotime($order->updated_at))}}</td>
                                </tr>
                            </table>
                            <table class="table col-sm-6 my-0">
                                <tr class="row px-3">
                                    <td class="col-6">Borrow Date:</td>
                                    <td class="col-6">{{date('F d, Y', strtotime($order->borrow_date))}}</td>
                                </tr>
                                <tr class="row px-3">
                                    
                                    <td class="col-6">Return Date:</td>
                                    <td class="col-6">{{date('F d, Y', strtotime($order->return_date))}}</td>
                                </tr>
                            </table>
                        </div>
                        
                        <div class="order card-footer">
                            <form action="{{ route('orders.destroy', ['order' => $order->id]) }}" method="post" class="text-right">
                                @csrf
                                @method('delete')
                                <a href="{{ route('orders.show', ['order' => $order->id]) }}" class="btn btn-primary btn-sm">View Details</a>
                                <button class="btn btn-danger btn-sm" type="submit">Delete</button>
                            </form>
                        </div>
                    </div>
                </div>
                @endcan
            @endforeach    
            {{-- End Order Item List --}}
        </div>
    </div>
</div>

@endsection

hector-fleet-management-system-master/resources/views/orders/show.blade.php
@extends('layouts/app')

@section('content')

{{-- MESSAGES --}}

<div class="row">

	@include('messages')

		<div class="col-sm-4 mb-2">
			
		{{-- START REQUESTED SIDE BAR --}}
		@if($order->order_status_id !== 1 || Auth::user()->role_id === 1)
	        <div class="card mb-3">
				<div class="card-header order-show">
	                <h5 class="float-left mb-0">Requested Vehicles</h5>
				</div>
				<div class="card-body">

	                {{-- Start Vehicle Items --}}
	                @if($order->status_id !== 1 && $order->vehicle_models->first)
						@foreach($order->vehicle_models as $request_model)
						@php
							$approved = count($order->vehicles()->where('vehicle_model_id', $request_model->id)->get());
							$required = $request_model->pivot->quantity;
						@endphp
		                    <div class="row">
		                        <div class="col-12">
		                            <div class="row mb-2">
		                                <div class="col-6 col-sm-4">
		                                    <img src="/public/{{$request_model->image}}" alt="" class="img-fluid">
		                                </div>
		                                <div class="col-8">
	                                        <p class="mb-0">{{ "$request_model->make $request_model->name" }} | <small>{{$request_model->year}}</small></p>
											<p class="
											@if($approved < $required)
												bg-grey
											@elseif($approved = $required)
												bg-success
											@elseif($approved > $required)
												bg-danger
											@endif
											d-inline py-1 px-2 text-light">Approved: {{ "$approved / $required" }}</p>
		                                </div>
		                            </div>
		                        </div>
		                    </div>
		                    <hr>
		                @endforeach
		                @else
		                    <span class="text-center d-block">Your request list is empty</span>
	                @endif
	                {{-- End Vehicle Items --}}
	                
				</div>
				<div class="order-show card-footer">

				</div>
	        </div>
        @endif
		{{-- END REQUESTED SIDE BAR --}}


		{{-- START ORDER DETAILS --}}
			<div class="card">
				<div class="card-header order-show">
					<h5 class="mb-0 d-inline">{{ $order->order_number }}</h5>
					<div class="badge d-inline mb-1 px-2 py-1 text-light
						@if($order->order_status->id == 2 && date('Y-m-d') > $order->return_date)
							bg-danger
						@elseif($order->order_status_id === 1)
							bg-grey
						@elseif($order->order_status_id === 2)
							bg-success
						@elseif($order->order_status_id === 3)
							bg-primary
						@elseif($order->order_status_id === 4)
							bg-warning
						@endif
					">
						{{ $order->order_status->id == 2 && date('Y-m-d') > $order->return_date? "OVERDUE" : $order->order_status->name }}
					</div>
					
				</div>
				@if($order->order_status_id === 1 || Auth::user()->role_id === 1)
					<form action="{{ route('orders.update', ['order' => $order->id]) }}" method="post">
						@csrf
						@method('put')
				@endif
				<div class="card-body p-3">
					<div class="row mb-3">
						<div class="col-sm-6 border-right">
							<div class="col-12 p-0">
								<p class="mb-0">Requested by:</p>
								<p class="mb-0">{{ ucwords($order->user->firstname . " " . $order->user->lastname) }}</p>
								<p class="mb-0">Date Requested:</p>
								<p class="mb-0">{{ date('M d, Y', strtotime($order->created_at)) }}</p>
							</div>
						</div>
						<div class="col-sm-6">
							<div class="col-12 p-0">
								<p class="mb-0">Borrow Date:</p>
								@if($order->order_status_id === 1 && Auth::user()->cannot('isMod'))
									<input type="date" name="borrow_date" class="form-control" value="{{ $order->borrow_date }}">
								@else
									<p class="mb-0">{{ date('F d, Y', strtotime($order->borrow_date)) }}</p>

								@endif

								<p class="mb-0">Return Date:</p>
								@if($order->order_status_id === 1 && Auth::user()->cannot('isMod'))
									<input type="date" name="return_date" class="form-control" value="{{ $order->return_date }}">
								@else
									<p class="mb-0">{{ date('F d, Y', strtotime($order->return_date)) }}</p>
								@endif
							</div>
						</div>
					</div>
					<div class="row">
						<div class="col-12 border-top py-3">
							<p class="mb-0">Purpose: </p>

							@if($order->order_status_id === 1 && Auth::user()->id == $order->user_id)
								<textarea name="purpose" rows="5" class="form-control">{{ $order->purpose }}</textarea>
							@else
								<p>{{ $order->purpose }}</p>
							@endif

						</div>
						@can('isAdmin')
							<div class="col-12 p-3">
								<p class="mb-0">Status:</p>
								<div class="form-check form-check-inline">
									{{-- START STATUS ITEMS --}}
									@foreach($statuses as $status)
									<input type="radio" class="form-check-input" name="status" id="{{ $status->name }}" value="{{ $status->id }}" {{ $status->id == $order->order_status->id ? "checked" : "" }}>
										<label class="form-check-label mr-4" for="status-STATUS">{{ $status->name }}</label>
									@endforeach
									{{-- END STATUS ITEMS --}}
								</div>
							</div>
						@endcan
					</div>
				</div>
				@if($order->order_status_id === 1 || Auth::user()->role_id === 1)
					<div class="card-footer order-show">
						<button type="submit" class="btn btn-primary w-100">Update Order</button>
						@can('isAdmin')
						<button type="submit" class="btn btn-danger w-100 mt-3" name="reject" value="reject">Reject Order</button>
						@endcan
					</div>
				</form>
				@endif
			</div>

				@if($order->order_status->id == 1 || Auth::user()->can('isAdmin'))
					<div class="col-12">
						<form action="{{ route('orders.destroy', ['order' => $order->id]) }}" method="post" class="text-center">
							@csrf
							@method('delete')
							<button type="submit" class="btn text-danger ml-auto font-weight-bold">Cancel Order</button>
						</form>
					</div>
				@endif
		</div>
	{{-- END ORDER DETAILS --}}
	
	    <div class="col-sm-8">
	    	
			{{-- START REQUESTED VEHICLE MAIN --}}
			@if($order->order_status_id === 1 && Auth::user()->role_id !== 1 && $order->vehicle_models->first())
	        <div class="card mb-3">
				<div class="card-header order-show">
	                <h5 class="float-left mb-0">Requested Vehicles</h5>
				</div>
				<div class="card-body">

	                {{-- Start Vehicle Items --}}
	                @if($order->vehicle_models()->first())
	                <div class="row">
	                	
	                @foreach($order->vehicle_models as $request_model)
	                    <div class="col-6 col-sm-4 p-1">
	                    	<div class="card">
	                    		<div class="col-12 px-1">
	                    			<form action="{{ route('orders.update', ['order' => $order->id]) }}?delete={{ $request_model->id }}" class="float-right" method="post">
                    				    @csrf
                    				    @method('put')
                    				    <button class="btn text-danger p-0" data-toggle="tooltip" name="delete-model" value="delete" title="Remove from Order">
                    				        <i class="far fa-times-circle"></i>
                    				    </button>
                    				</form>
	                    		</div>
	                    		<img src="/public/{{ $request_model->image }}" alt="" class="img-fluid card-img-top">
	                    		<div class="card-body p-0">
	                    			<div class="col-12 text-center">
	                    				<span class="mb-0 font-weight-bold">{{ "$request_model->make $request_model->name $request_model->year" }}</span>
	                    			</div>
	                    			<div class="col-12 px-0">
	                    				<form action="{{ route('orders.update', ['order' => $order->id]) }}?updateQuantity={{ $request_model->id }}" method="post">
	                    					@csrf
	                    					@method('put')
	                    					<div class="form-group flex-fill row mb-0">
			                                   <div class="col-12 input-group">
			                                       <input type="number" class="form-control p-1 text-center" name="quantity" value="{{$request_model->pivot->quantity}}" min="1">
			                                       <div class="input-group-append">
			                                           <button class="btn btn-primary btn-sm w-100 h-100">Update</button>
			                                       </div>
			                                   </div>
			                                   <div class="col-8 pl-0">
			                                   </div>
			                               </div>
	                    				</form>
	                    			</div>
	                    		</div>
	                    	</div>
	                    </div>
	                @endforeach
	                </div>

	                @else
	                    <span class="text-center d-block">Order is empty</span>
	                @endif
	                {{-- End Vehicle Items --}}
	                
				</div>
	        </div>
	        @endif
			{{-- END REQUESTED VEHICLE MAIN --}}
			
			{{-- START ASSIGNED VEHICLES MAIN --}}
	        @if($order->order_status_id !== 1 || Auth::user()->role_id != 3)
            <div class="card mb-3">
    			<div class="card-header order-show">
                    <h5 class="float-left mb-0">Approved Vehicles</h5>
    			</div>
    			<div class="card-body">

                    {{-- Start Vehicle Items --}}	                
                    <div class="row">	
                    @foreach($order->vehicles as $assigned_vehicle)
                        <div class="col-6 col-sm-3 col-lg-2 p-1">
                        	<div class="card">
                        		<img src="/public/{{ $assigned_vehicle->vehicle_model->image }}" alt="" class="img-fluid card-img-top small">
                        		<div class="card-body p-0">
                        			<div class="col-12 text-center">
                        				<span class="mb-0 font-weight-bold">{{ $assigned_vehicle->plate_number }}</span>
                        			</div>
                        			<div class="col-12 px-0">
                        				<a href="{{ route('vehicles.show', ['vehicle' => $assigned_vehicle->id]) }}" class="btn btn-primary btn-sm w-100">View Details</a>
									</div>
									@can('isAdmin')
										<div class="col-12 px-0">
											<form action="{{ route('orders.update', ['order' => $order->id]) }}?unassign={{ $assigned_vehicle->id }}" method="post">
												@csrf
												@method('put')
												<button type="submit" class="btn btn-danger btn-sm w-100">Unassign</button>
											</form>
										</div>
									@endcan
                        		</div>
                        	</div>
					</div>
                    @endforeach
                    </div>
                    {{-- End Vehicle Items --}}
                    
				</div>
				<div class="card-footer order-show">
					<form action="{{route('orders.update', ['order' => $order->id])}}">
					
					</form>
				</div>
            </div>
			@endif
			{{-- END ASSIGNED VEHICLES MAIN --}}

	        {{-- START AVAILABLE VEHICLE MAIN --}}
	        @can('isAdmin')
            <div class="card">
    			<div class="card-header order-show">
                    <h5 class="float-left mb-0">Available Vehicles</h5>
    			</div>
    			<div class="card-body">

                    {{-- Start Vehicle Items --}}	                
                    <div class="row">	
                    @foreach($vehicles as $vehicle)
                        <div class="col-6 col-sm-4 col-lg-3 p-1">
                        	<div class="card">
                        		<img src="/public/{{ $vehicle->vehicle_model->image }}" alt="" class="img-fluid card-img-top mid">
                        		<div class="card-body p-0">
                        			<div class="col-12 text-center">
                        				<span class="mb-0 font-weight-bold">{{ $vehicle->plate_number }}</span>
                        			</div>
                        			<div class="col-12 px-0">
                        				<a href="{{ route('vehicles.show', ['vehicle' => $vehicle->id]) }}" class="btn btn-primary w-100">View Details</a>
                        			</div>
                        			<div class="col-12 px-0">
										<form action="{{ route('orders.update', ['order' => $order->id]) }}?assign={{ $vehicle->id }}" method="post">
											@csrf
											@method('put')
											<button type="submit" class="btn btn-secondary w-100">Assign</button>
										</form>
                        			</div>
                        		</div>
                        	</div>
					</div>
                    @endforeach
                    </div>
                    {{-- End Vehicle Items --}}
                    
    			</div>
            </div>
			
			<div class="card-footer order-show">
				<div class="mx-auto">
					{{-- {{$vehicles->links()}} --}}
				</div>
			</div>
			@endcan
			{{-- END AVAILABLE VEHICLE MAIN --}}
			
		</div>
		{{-- {{ dd($vehicles) }} --}}
		{{-- END  MAIN --}}

	
</div>

@endsection